(define (mod a b)
    (- a (* (trunc (/ a b)) b))
)

(define (div a b)
    (if (> (- (/ a b) (trunc (/ a b))) 0)
	(trunc (/ a b))
	(+ (trunc (/ a b) 1))
    )
)

(define (ceil a)
    (if (= (trunc a) a)
	a
	(+ (trunc a) 1)
    )
)

(define (put-img img draw list weight height number pos)
    (set! img-tile (car (gimp-file-load 1 (car list) (car list))))
    (set! draw-tile (car (gimp-image-active-drawable img-tile)))

    (gimp-edit-copy draw-tile)
    (gimp-rect-select img (* (mod pos number) weight) (* (div pos number) height) weight height CHANNEL-OP-REPLACE 0 0)
    (gimp-edit-paste draw TRUE)
    (gimp-image-merge-visible-layers img CLIP-TO-IMAGE)

    (if (not (null? (cdr list)))
	(put-img img draw (cdr list) weight height number (+ pos 1))
    )
)

(define (r-tiles list fileout weight height number)
    (set! img-weight (* weight number))
    (set! img-height (* (ceil (/ (length list) number)) height))
    
    (set! img (car (gimp-file-load 1 (car list) (car list))))
    (set! draw (car (gimp-image-active-drawable img)))
	    
    (gimp-drawable-fill draw TRANSPARENT-FILL)
    (gimp-image-scale img img-weight img-height)

    (put-img img draw list weight height number 0)

;    (plug-in-threshold-alpha 1 img draw 255)
    (file-png-save 1 img draw fileout fileout 0 9 0 0 0 0 0)
    
;    (alpha-threshold fileout fileout 128)
)

(script-fu-register "r-tiles"
	_"<Toolbox>/Xtns/Script-Fu/Batch/Tiles"
	_"Build a tile from files"
        "Frederic Rodrigo"
        "Frederic Rodrigo"
        "16 Sep 2004"
        ""
	SF-STRING     _"List" "()"
        SF-STRING     _"File Out" ""
        SF-ADJUSTMENT _"W" '(64 1 1024 1 10 0 1)
        SF-ADJUSTMENT _"H" '(32 1 512 1 10 0 1)
        SF-ADJUSTMENT _"X" '(8 1 1024 1 10 0 1)
)
