#!/usr/bin/perl

use XML::Parser;
use Data::Dumper;

require 'dumpvar.pl';



sub xml_args_render {
    my ($args) = @_;
    my $str;
    my $arg;

    foreach $arg (sort keys %$args) {
        $str .= " " . $arg . "=\"$$args{$arg}\"";
    }

    return $str;
}

sub xml_render {
    my ($tree) = @_;
    my $str;
    my $i;

    $i = 0;
    while (defined $$tree[$i]) {
        if (ref $$tree[$i] eq 'HASH') {
            $str .= &xml_args_render ($$tree[$i]);
            $i ++;
#            $str .= '/' if not defined $$tree[$i];
            $str .= '>';
        } else {
            if ($$tree[$i] eq '0') {
                $str .= $$tree[$i + 1];
            } else {
                $str .= '<' . $$tree[$i];
                $str .= &xml_render ($$tree[$i + 1]);
                $str .= "</" . $$tree[$i] . ">"; # if defined $ {$$tree[$i + 1]}[1];
            }
            $i += 2;
        }
    }

    return $str;
}

sub svg_render
{
    my ( $tree, $file ) = @_;
    open( fd, ">$file" );
    print fd '<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 20010904//EN"
"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd">
<!-- Created with Inkscape (http://www.inkscape.org/) -->
';
    print fd xml_render( $tree );
    close( fd );
}





sub xml_find
{
  my ($tree, $where, $what) = @_;

  my $i = 0;
  while( defined $$tree[$i] )
    {
     if( ref $$tree[$i] eq 'HASH' )
       {
        if( $$tree[$i]{$where} eq $what )
          {
	   return $$tree[$i];
          }
        $i++;
       }
     else
       {
        if( $$tree[$i] eq '0' )
          {
          }
        else
          {
           my $ret = xml_find( $$tree[$i+1], $where, $what );
	   if( $ret )
	   {
	      return $ret;
	   }
          }
        $i += 2;
       }
    }
 return 0;
}


sub edit_style
{
    my ( $style, $attrib, $value ) = @_;
    my @coup = split( /;/, $style );
    foreach $i (@coup)
    {
	my ( $a, $v ) = split( /:/, $i );
	if( $attrib eq $a )
	{
	    $_ = $style;
	    s/(.*^|;)$attrib:([^;]*);(.*)/$1$attrib:$value;$3/;
	    return $_;
	}
    }
    return $style."$attrib:$value;";
}
